var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React from 'react';
import PropTypes from 'prop-types';
import { createComponent } from 'cf-style-container';
import ReactTooltip from 'react-tooltip';
import uniqueId from 'lodash.uniqueid';

var getBackgroundColor = function getBackgroundColor(colors, type) {
  if (type === 'dark') {
    return colors.gray[1] + ' !important';
  }

  if (type === 'success') {
    return colors.green[6] + ' !important';
  }

  return 'inherit';
};
var tooltipStyles = function tooltipStyles(_ref) {
  var theme = _ref.theme,
      type = _ref.type,
      place = _ref.place;
  return {
    '&:after': {
      borderTopColor: place === 'top' ? getBackgroundColor(theme.colors, type) : 'inherit',
      borderRightColor: place === 'right' ? getBackgroundColor(theme.colors, type) : 'inherit',
      borderLeftColor: place === 'left' ? getBackgroundColor(theme.colors, type) : 'inherit',
      borderBottomColor: place === 'bottom' ? getBackgroundColor(theme.colors, type) : 'inherit'
    },
    backgroundColor: getBackgroundColor(theme.colors, type),
    opacity: '1!important',
    fontSize: '0.8rem!important',
    borderRadius: '2px!important',
    maxWidth: '21rem!important',
    padding: '0.5rem 1rem!important',
    fontWeight: 'normal!important',
    lineHeight: '1.5!important',
    pointerEvents: 'auto !important',
    verticalAlign: 'baseline!important',
    whiteSpace: 'normal',
    '&:hover': {
      visibility: 'visible!important',
      opacity: '1!important'
    }
  };
};

var Tooltip = function (_React$Component) {
  _inherits(Tooltip, _React$Component);

  function Tooltip(props) {
    _classCallCheck(this, Tooltip);

    var _this = _possibleConstructorReturn(this, (Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).call(this, props));

    _this.id = uniqueId('cf_component_tooltip_');
    return _this;
  }

  _createClass(Tooltip, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var _this2 = this;

      ReactTooltip.rebuild();

      // full rebuild is required when tooltip is already displayed
      // but we changed type of position of the tooltip
      if (this.props.forceRebuild) {
        ReactTooltip.hide(this.tooltipElement);
        setTimeout(function () {
          return ReactTooltip.show(_this2.tooltipElement);
        }, 0);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          place = _props.place,
          message = _props.message,
          children = _props.children,
          className = _props.className,
          delayHide = _props.delayHide,
          afterHide = _props.afterHide,
          afterShow = _props.afterShow,
          getContent = _props.getContent,
          type = _props.type;

      var id = this.props.id ? this.props.id : this.id;
      return React.createElement(
        'span',
        null,
        React.createElement(ReactTooltip, {
          id: id,
          place: place,
          type: type,
          'aria-haspopup': 'true',
          role: 'tooltip',
          effect: 'solid',
          className: className,
          isCapture: true,
          delayHide: delayHide ? delayHide : null,
          afterShow: afterShow,
          afterHide: afterHide,
          getContent: [function () {
            return message || getContent();
          }]
        }),
        React.createElement(
          'div',
          {
            ref: function ref(c) {
              _this3.tooltipElement = c;
            },
            'data-tip': true,
            'data-for': id
          },
          children
        )
      );
    }
  }]);

  return Tooltip;
}(React.Component);

Tooltip.propTypes = {
  id: PropTypes.string,
  message: PropTypes.node.isRequired,
  place: PropTypes.oneOf(['top', 'right', 'bottom', 'left']),
  type: PropTypes.oneOf(['dark', 'success', 'warning', 'error', 'info', 'light']),
  className: PropTypes.string,
  children: PropTypes.node,
  delayHide: PropTypes.number,
  afterHide: PropTypes.func,
  afterShow: PropTypes.func,
  getContent: PropTypes.func,
  forceRebuild: PropTypes.bool
};

Tooltip.defaultProps = {
  position: 'top',
  type: 'dark',
  forceRebuild: false
};

Tooltip.displayName = 'Tooltip';

export default createComponent(tooltipStyles, Tooltip, ['message', 'id', 'place', 'className', 'children', 'afterHide', 'afterShow', 'getContent', 'type', 'forceRebuild']);